"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const rc_trigger_1 = __importDefault(require("rc-trigger"));
const classnames_1 = __importDefault(require("classnames"));
const prefixCls_1 = __importDefault(require("./prefixCls"));
const placements_1 = __importDefault(require("./placements"));
const Panel_1 = __importDefault(require("./Panel"));
const tinycolor2_1 = __importDefault(require("tinycolor2"));
const prevent_default_1 = __importDefault(require("@segment/prevent-default"));
const use_optional_state_1 = __importDefault(require("use-optional-state"));
const ColorPicker = props => {
    const { className, value: propsValue, defaultValue, onChange, align, popupPlacement, getPopupContainer, popupStyle, animated, enableAlpha } = props;
    const [value, setValue] = use_optional_state_1.default({
        initialValue: defaultValue,
        controlledValue: propsValue,
        onChange
    });
    const handlePopupVisibleChange = open => {
        setValue(Object.assign(Object.assign({}, value), { open }));
    };
    const handleToggle = () => {
        setValue(Object.assign(Object.assign({}, value), { open: !value.open }));
    };
    return (react_1.default.createElement("div", { className: classnames_1.default(className, `${prefixCls_1.default}-wrap`, value.open && `${prefixCls_1.default}-open`) },
        react_1.default.createElement(rc_trigger_1.default, { popup: react_1.default.createElement(Panel_1.default, { value: value, enableAlpha: enableAlpha, prefixCls: `${prefixCls_1.default}-panel`, onChange: setValue, className: className }), popupAlign: align, builtinPlacements: placements_1.default, popupPlacement: popupPlacement, action: 'click', destroyPopupOnHide: true, getPopupContainer: getPopupContainer, popupStyle: popupStyle, popupMotion: animated ? { motionName: `${prefixCls_1.default}-slide-up` } : undefined, popupVisible: value.open, onPopupVisibleChange: handlePopupVisibleChange, prefixCls: prefixCls_1.default },
            react_1.default.createElement("span", { className: `${prefixCls_1.default}-trigger`, unselectable: 'on', style: {
                    backgroundColor: value.color.toHexString()
                }, onClick: handleToggle, onMouseDown: prevent_default_1.default }))));
};
ColorPicker.defaultProps = {
    defaultValue: { color: new tinycolor2_1.default('#F00'), open: false },
    enableAlpha: true,
    popupPlacement: 'topLeft',
    animated: false
};
exports.default = ColorPicker;
