"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const tinycolor2_1 = __importDefault(require("tinycolor2"));
const setChannelValue = (color, mode, channelIndex, value) => {
    if (mode === 'RGB') {
        const rgb = color.toRgb();
        switch (channelIndex) {
            case 0:
                return new tinycolor2_1.default(Object.assign(Object.assign({}, rgb), { r: value }));
            case 1:
                return new tinycolor2_1.default(Object.assign(Object.assign({}, rgb), { g: value }));
            default:
                return new tinycolor2_1.default(Object.assign(Object.assign({}, rgb), { b: value }));
        }
    }
    else {
        const hsl = color.toHsl();
        switch (channelIndex) {
            case 0:
                return new tinycolor2_1.default(Object.assign(Object.assign({}, hsl), { h: value }));
            case 1:
                return new tinycolor2_1.default(Object.assign(Object.assign({}, hsl), { s: value }));
            default:
                return new tinycolor2_1.default(Object.assign(Object.assign({}, hsl), { l: value }));
        }
    }
};
exports.default = setChannelValue;
